<template>
  <div class="col s12 m6">
    <div>
      <div class="page-subtitle">
        <h4>{{ 'Create' | localization }}</h4>
      </div>

      <form @submit.prevent="submitHandler">
        <div class="input-field">
          <input
              id="name"
              type="text"
              v-model.trim="name"
              :class="{invalid: $v.name.$dirty && !$v.name.required}"
          >
          <label for="name">{{ 'Title' | localization }}</label>

          <span v-if="$v.name.$dirty && !$v.name.required" class="helper-text invalid">
            {{ 'Enter title' | localization }}
          </span>

        </div>

        <div class="input-field">
          <input
              id="limit"
              type="number"
              v-model="limit"
              :class="{invalid: $v.name.$dirty && !$v.name.minValue}"
          >
          <label for="limit">{{ 'Limit' | localization }}</label>

          <span v-if="$v.limit.$dirty && !$v.limit.minValue" class="helper-text invalid">
            {{ 'Limit must be numeric' | localization }}
          </span>

        </div>

        <button class="btn waves-effect waves-light" type="submit">
          {{ 'Create' | localization }}
          <i class="material-icons right">send</i>
        </button>
      </form>
    </div>
  </div>
</template>

<script>
import {required, minValue} from 'vuelidate/lib/validators';
import localization from "@/filters/localization";

export default {
  name: "Creation",
  data: () => ({
    name: null,
    limit: 1
  }),
  validations: {
    name: {required},
    limit: {minValue: minValue(1)}
  },
  mounted() {
    M.updateTextFields();
  },
  methods: {
    async submitHandler() {
      if (this.$v.$invalid) {
        this.$v.$touch();
        return false;
      }

      const formData = {
        name: this.name,
        limit: this.limit
      };

      try {
        const category = await this.$store.dispatch('addCategory', formData);
        this.$message(localization('Category added'));
        this.name = '';
        this.limit = 1;
        this.$v.$reset();
        this.$emit('created', category);
      } catch (e) {}
    }
  }
}
</script>

<style scoped>

</style>